import { type Component } from 'vue';
import type { AllItems, CustomItem, CustomItemOptions, Item, ItemGroup, ItemGroupOptions, ItemOptions } from './types';
export declare function itemGroup<WrapperComponent>(options: ItemGroupOptions<WrapperComponent>): ItemGroup<WrapperComponent>;
export declare function item<Meta = unknown, WrapperComponent = unknown, ElementTag = unknown>(options: ItemOptions<Meta, WrapperComponent, ElementTag>): Item<Meta, WrapperComponent, ElementTag>;
export declare function customItem<Meta = unknown>(options: CustomItemOptions<Meta>): CustomItem<Meta>;
export declare function isItemGroup(value: unknown): value is ItemGroup;
export declare function isItem(value: unknown): value is Item;
export declare function isCustomItem(value: unknown): value is CustomItem;
export declare function isComponent(value: unknown): value is Component;
export declare const getFlattenedItems: (items: AllItems[], seenItems?: (Item | CustomItem)[]) => (Item | CustomItem)[];
