import type { FunctionalComponent, Ref } from 'vue';
export declare type AllItems = Item<any> | CustomItem<any> | ItemGroup;
declare type GetComponentOrElementProps<C> = C extends string ? C extends keyof JSX.IntrinsicElements ? JSX.IntrinsicElements[C] : Record<string, unknown> : C extends FunctionalComponent<infer Props> ? Props : C extends new () => {
    $props: infer Props;
} ? Props : Record<string, unknown>;
declare type GetElemenAttrs<T> = T extends string ? T extends keyof JSX.IntrinsicElements ? JSX.IntrinsicElements[T] : Record<string, unknown> : Record<string, unknown>;
export interface ItemGroup<WrapperComponent = unknown, Props = GetComponentOrElementProps<WrapperComponent>> {
    key: string;
    type: symbol;
    wrapperComponentOrTag?: WrapperComponent;
    wrapperProps?: Props;
    items: AllItems[];
}
export interface Item<Meta = unknown, WrapperComponent = unknown, ElementTag = unknown, WrapperProps = GetComponentOrElementProps<WrapperComponent>, ElementAttrs = {
    key?: undefined;
    ref?: Ref<HTMLElement | null | undefined> | ((el: HTMLElement) => void);
} & GetElemenAttrs<ElementTag>> {
    key: string;
    type: symbol;
    wrapperComponentOrTag?: WrapperComponent;
    wrapperProps?: WrapperProps;
    elementTag?: ElementTag;
    elementAttrs?: ElementAttrs;
    onSelect?: (meta: Meta) => void;
    meta?: Meta;
}
export interface CustomItem<Meta = unknown> {
    key: string;
    type: symbol;
    name: string;
    meta?: Meta;
}
export declare type OnFocusHook = (meta: unknown, el: HTMLElement) => void;
export declare type OnUnfocusHook = (meta: unknown, el: HTMLElement) => void;
export declare type OnSelectHook = (meta: unknown, el: HTMLElement) => void;
export declare type CustomItemOptions<Meta = unknown> = Omit<CustomItem<Meta>, 'type'>;
export declare type ItemOptions<Meta = unknown, WrapperComponent = unknown, ElementTag = unknown> = Omit<Item<Meta, WrapperComponent, ElementTag>, 'type'>;
export declare type ItemGroupOptions<WrapperComponent = unknown> = Omit<ItemGroup<WrapperComponent>, 'type'>;
export {};
